<template>
  <b-tab title-link-class="custom-tabs"
  title="Informations principales" active>
    <template #title>
      <b-icon icon="info-circle"></b-icon> Informations principales
    </template>
            <h3 class="line-header">Description de la couche</h3>

            <FormTextInput v-bind:label="'Titre'" v-model="layer.title"/>
            <FormTextInput v-bind:label="'Description'" v-model="layer.description"/>
            <FormTextInput v-bind:label="'Lien vers les métadonnées'" v-model="layer.metadataUrl"/>
            <FormTextInput v-bind:label="'Nom de la couche'" v-model="layer.layername"/>
            <FormTextInput v-bind:label="'Url'" v-model="layer.url" :cols="7" :md="7">
              <b-col cols="1" align-self="end">
                <b-button variant="outline-secondary" :pressed.sync="showAuthInfos"
                  title="Informations d'authentification" class="w-100">
                  <b-icon :icon="layer.authenticationInfos.isFilled()?'lock':'unlock'"></b-icon>
                </b-button>
              </b-col>
            </FormTextInput>
            <FormTextInput v-if="layer.protocol=='TMS' && layer.type== 'VectorTile'"
              v-bind:label="'Url du style Mapbox'" v-model="layer.mbStyleUrl" ></FormTextInput>
            <AuthenticationInfoPanel
              v-if="showAuthInfos" :url="layer.url"
              :authenticationInfos="layer.authenticationInfos"/>

            <b-row v-if="layer.hasEditionCapabilities()">
              <b-col cols="4" >
                <b-form-checkbox
                  v-model="layer.editable" switch>
                    Editable
                </b-form-checkbox>
              </b-col>
            </b-row>

            <b-row>
              <b-col cols='4'>
                <label>Type de géometrie :</label>
              </b-col>
              <b-col cols='8'>
                <b-form-select
                  v-model="layer.geometryType" :options="geometryTypeList"></b-form-select>
              </b-col>
            </b-row>

            <FormNumberInput v-if="layer.type == 'WFS' || layer.type == 'WMS'"
              v-bind:label="'Nombre d\'objets max affichés'"
              :tooltip="'Nombre d\'objets max demandé au serveur WFS'"
            v-model="layer.maxFeatures"/>
            <FormTextInput v-if="debug"
              v-bind:label="'Format des requetes getfeatureInfo'"
              v-model="layer.getFeatureInfoFormat"/>

            <h3 class="line-header">Filtrer</h3>
           <FormTextInput v-bind:label="'Filtre'" v-model="layer.filter" :cols="7" :md="7">
              <b-col cols="1" align-self="end">
                <b-button variant="light" :pressed.sync="showFilterPanel"
                  title="Ajouter un filtre">
                  <b-icon
                    icon="plus"
                    variant="info"></b-icon>
                </b-button>
              </b-col>
            </FormTextInput>
            <AddFilterPanel :layer="layer" v-if="showFilterPanel" @add_filter="addFilter($event)"/>
            <h3 class="line-header">Visibilité dépendante de l'échelle</h3>
            <!-- Attention ici avec les termes, on affiche minimum
            à l utilisateur comme c'est fait dans qgis mais on stocke
            le denominator donc min devient max
            -->
            <FormTextInput v-bind:label="'Minimum'"
              :tooltip="'Echelle minimale, c\'est à dire la plus dé-zoomée, qui couvre un territoire plus large'"
            v-model="layer.maxScaleDenominator"/>
            <FormTextInput v-bind:label="'Maximum'"
              :tooltip="'Echelle maximale, c\'est à dire la plus zoomée, qui couvre un territoire plus petit'"
            v-model="layer.minScaleDenominator"/>
            <h3 class="line-header">Légende</h3>
            <b-form-row>
              <b-col cols="4" >
                <b-form-checkbox
                  v-model="layer.isLegendDisplayed" switch>
                    Afficher une légende pour cette couche
                </b-form-checkbox>
              </b-col>
            </b-form-row>
            <h3 class="line-header">Emprise (WGS 84)</h3>
            <b-row>
              <b-col :cols="2">
                <label v-b-tooltip.hover title="tooltip">MinX</label>
                  <input type="number" min="-180" max="180" step="0.01"
                  class="form-control form-control-sm"
                  v-model="layer.boundingBoxEPSG4326[0]"/>
              </b-col>
                <b-col :cols="2">
                <label v-b-tooltip.hover title="tooltip">MinY</label>
                  <input type="number" min="-180" max="180" step="0.01"
                  class="form-control form-control-sm"
                  v-model="layer.boundingBoxEPSG4326[1]"/>
              </b-col>
                <b-col :cols="2">
                <label v-b-tooltip.hover title="tooltip">MaxX</label>
                  <input type="number" min="-180" max="180" step="0.01"
                  class="form-control form-control-sm"
                  v-model="layer.boundingBoxEPSG4326[2]"/>
              </b-col>
              <b-col :cols="2">
                <label v-b-tooltip.hover title="tooltip">MaxY</label>
                  <input type="number" min="-180" max="180" step="0.01"
                  class="form-control form-control-sm"
                  v-model="layer.boundingBoxEPSG4326[3]"/>
              </b-col>
              <b-col :cols="1" align-self="center" class="text-first">
                Ou
              </b-col>
              <b-col :cols="3" align-self="center">
                <b-button size="sm" variant="outline-secondary"
                      class="w-100 mb-3" @click="useMapBounds()">
                      Utiliser l'emprise courante de la carte</b-button>
                      <p class="italic font_size_13 justify text-second">
                          <b-icon icon="info-circle"
                            aria-hidden="true" class="text-second"></b-icon>
                          Cliquez sur le bouton ci-dessus pour utiliser la vue
                          courante pour définir l'emprise de la couche
                          Vous pouvez aussi entrer manuellement les coordonnées
                      </p>
              </b-col>
            </b-row>
            <h3 class="line-header">Copyrights</h3>
            <FormTextInput v-bind:label="'Copyright'"
            v-model="layer.Attribution.Title"/>
            <FormTextInput v-bind:label="'Url'"
            v-model="layer.Attribution.OnlineResource"/>
  </b-tab>
</template>

<script lang="ts">
/* eslint-disable class-methods-use-this */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
import FormTextInput from '@/components/shared/FormTextInput.vue';
import AuthenticationInfoPanel from '@/components/shared/AuthenticationInfoPanel.vue';
import AddFilterPanel from '@/components/layers/AddFilterPanel.vue';
import GeometryType from '@/models/map-context/GeometryType';
import LayerConfig from '@/models/map-context/LayerConfig';
import Component from 'vue-class-component';
import FormNumberInput from '@/components/shared/FormNumberInput.vue';
import BaseComponent from '../../BaseComponent';

@Component({
  props: {
    layer: LayerConfig,
  },
  components: {
    FormTextInput,
    FormNumberInput,
    AuthenticationInfoPanel,
    AddFilterPanel,
  },
})
export default class SingleLayerMainInfos extends BaseComponent {
  layer!: LayerConfig;

  showAuthInfos = false;

  showFilterPanel = false;

  geometryTypeList = [GeometryType.UNDEFINED,
    GeometryType.LINE, GeometryType.POINT, GeometryType.POLYGON];

  addFilter(filter:string) :void{
    if (this.layer.filter && this.layer.filter.length > 0) {
      this.layer.filter = `(${this.layer.filter} AND ${filter})`;
    } else {
      this.layer.filter = filter;
    }

    this.showFilterPanel = false;
  }

  useMapBounds() {
    const mapExtent = this.getMapService().getMapBoundsWGS84();
    console.log(mapExtent);
    this.layer.boundingBoxEPSG4326 = mapExtent;
  }
}
</script>

<style scoped lang="less">
</style>
